// **********************************************************************
//
// Copyright (c) 2003-2004 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 1.5.0
// Generated from file `Admin.ice'

using _System = System;
using _Microsoft = Microsoft;

namespace IcePack
{
    public enum ServerActivation
    {
	OnDemand,
	Manual
    }

    public struct ObjectDescriptor
    {
	#region Slice data members

	public Ice.ObjectPrx proxy;

	public string type;

	public string adapterId;

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int __h = 0;
	    if(proxy != null)
	    {
		__h = 5 * __h + proxy.GetHashCode();
	    }
	    if(type != null)
	    {
		__h = 5 * __h + type.GetHashCode();
	    }
	    if(adapterId != null)
	    {
		__h = 5 * __h + adapterId.GetHashCode();
	    }
	    return __h;
	}

	public override bool Equals(object __other)
	{
	    if(object.ReferenceEquals(this, __other))
	    {
		return true;
	    }
	    if(!(__other is ObjectDescriptor))
	    {
		return false;
	    }
	    if(proxy == null)
	    {
		if(((ObjectDescriptor)__other).proxy != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(proxy.Equals(((ObjectDescriptor)__other).proxy)))
		{
		    return false;
		}
	    }
	    if(type == null)
	    {
		if(((ObjectDescriptor)__other).type != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(type.Equals(((ObjectDescriptor)__other).type)))
		{
		    return false;
		}
	    }
	    if(adapterId == null)
	    {
		if(((ObjectDescriptor)__other).adapterId != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(adapterId.Equals(((ObjectDescriptor)__other).adapterId)))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(ObjectDescriptor __lhs, ObjectDescriptor __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(ObjectDescriptor __lhs, ObjectDescriptor __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(ObjectDescriptor __lhs, ObjectDescriptor __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion

	#region Marshalling support

	public void __write(IceInternal.BasicStream __os)
	{
	    __os.writeProxy(proxy);
	    __os.writeString(type);
	    __os.writeString(adapterId);
	}

	public void __read(IceInternal.BasicStream __is)
	{
	    proxy = __is.readProxy();
	    type = __is.readString();
	    adapterId = __is.readString();
	}

	#endregion
    }

    public struct AdapterDescriptor
    {
	#region Slice data members

	public string name;

	public string id;

	public string endpoints;

	public bool registerProcess;

	public IcePack.ObjectDescriptor[] objects;

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int __h = 0;
	    if(name != null)
	    {
		__h = 5 * __h + name.GetHashCode();
	    }
	    if(id != null)
	    {
		__h = 5 * __h + id.GetHashCode();
	    }
	    if(endpoints != null)
	    {
		__h = 5 * __h + endpoints.GetHashCode();
	    }
	    __h = 5 * __h + registerProcess.GetHashCode();
	    if(objects != null)
	    {
		__h = 5 * __h + objects.GetHashCode();
	    }
	    return __h;
	}

	public override bool Equals(object __other)
	{
	    if(object.ReferenceEquals(this, __other))
	    {
		return true;
	    }
	    if(!(__other is AdapterDescriptor))
	    {
		return false;
	    }
	    if(name == null)
	    {
		if(((AdapterDescriptor)__other).name != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(name.Equals(((AdapterDescriptor)__other).name)))
		{
		    return false;
		}
	    }
	    if(id == null)
	    {
		if(((AdapterDescriptor)__other).id != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(id.Equals(((AdapterDescriptor)__other).id)))
		{
		    return false;
		}
	    }
	    if(endpoints == null)
	    {
		if(((AdapterDescriptor)__other).endpoints != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(endpoints.Equals(((AdapterDescriptor)__other).endpoints)))
		{
		    return false;
		}
	    }
	    if(!(registerProcess.Equals(((AdapterDescriptor)__other).registerProcess)))
	    {
		return false;
	    }
	    if(objects == null)
	    {
		if(((AdapterDescriptor)__other).objects != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(objects.Equals(((AdapterDescriptor)__other).objects)))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(AdapterDescriptor __lhs, AdapterDescriptor __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(AdapterDescriptor __lhs, AdapterDescriptor __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(AdapterDescriptor __lhs, AdapterDescriptor __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion

	#region Marshalling support

	public void __write(IceInternal.BasicStream __os)
	{
	    __os.writeString(name);
	    __os.writeString(id);
	    __os.writeString(endpoints);
	    __os.writeBool(registerProcess);
	    __os.writeSize(objects.Length);
	    for(int __i = 0; __i < objects.Length; ++__i)
	    {
		objects[__i].__write(__os);
	    }
	}

	public void __read(IceInternal.BasicStream __is)
	{
	    name = __is.readString();
	    id = __is.readString();
	    endpoints = __is.readString();
	    registerProcess = __is.readBool();
	    int sz = __is.readSize();
	    __is.startSeq(sz, 4);
	    objects = new IcePack.ObjectDescriptor[sz];
	    for(int __i = 0; __i < objects.Length; ++__i)
	    {
		objects[__i].__read(__is);
		__is.checkSeq();
		__is.endElement();
	    }
	}

	#endregion
    }

    public struct PropertyDescriptor
    {
	#region Slice data members

	public string name;

	public string value;

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int __h = 0;
	    if(name != null)
	    {
		__h = 5 * __h + name.GetHashCode();
	    }
	    if(value != null)
	    {
		__h = 5 * __h + value.GetHashCode();
	    }
	    return __h;
	}

	public override bool Equals(object __other)
	{
	    if(object.ReferenceEquals(this, __other))
	    {
		return true;
	    }
	    if(!(__other is PropertyDescriptor))
	    {
		return false;
	    }
	    if(name == null)
	    {
		if(((PropertyDescriptor)__other).name != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(name.Equals(((PropertyDescriptor)__other).name)))
		{
		    return false;
		}
	    }
	    if(value == null)
	    {
		if(((PropertyDescriptor)__other).value != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(value.Equals(((PropertyDescriptor)__other).value)))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(PropertyDescriptor __lhs, PropertyDescriptor __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(PropertyDescriptor __lhs, PropertyDescriptor __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(PropertyDescriptor __lhs, PropertyDescriptor __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion

	#region Marshalling support

	public void __write(IceInternal.BasicStream __os)
	{
	    __os.writeString(name);
	    __os.writeString(value);
	}

	public void __read(IceInternal.BasicStream __is)
	{
	    name = __is.readString();
	    value = __is.readString();
	}

	#endregion
    }

    public struct DbEnvDescriptor
    {
	#region Slice data members

	public string name;

	public string dbHome;

	public IcePack.PropertyDescriptor[] properties;

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int __h = 0;
	    if(name != null)
	    {
		__h = 5 * __h + name.GetHashCode();
	    }
	    if(dbHome != null)
	    {
		__h = 5 * __h + dbHome.GetHashCode();
	    }
	    if(properties != null)
	    {
		__h = 5 * __h + properties.GetHashCode();
	    }
	    return __h;
	}

	public override bool Equals(object __other)
	{
	    if(object.ReferenceEquals(this, __other))
	    {
		return true;
	    }
	    if(!(__other is DbEnvDescriptor))
	    {
		return false;
	    }
	    if(name == null)
	    {
		if(((DbEnvDescriptor)__other).name != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(name.Equals(((DbEnvDescriptor)__other).name)))
		{
		    return false;
		}
	    }
	    if(dbHome == null)
	    {
		if(((DbEnvDescriptor)__other).dbHome != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(dbHome.Equals(((DbEnvDescriptor)__other).dbHome)))
		{
		    return false;
		}
	    }
	    if(properties == null)
	    {
		if(((DbEnvDescriptor)__other).properties != null)
		{
		    return false;
		}
	    }
	    else
	    {
		if(!(properties.Equals(((DbEnvDescriptor)__other).properties)))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool Equals(DbEnvDescriptor __lhs, DbEnvDescriptor __rhs)
	{
	    return object.ReferenceEquals(__lhs, null)
	               ? object.ReferenceEquals(__rhs, null)
	               : __lhs.Equals(__rhs);
	}

	public static bool operator==(DbEnvDescriptor __lhs, DbEnvDescriptor __rhs)
	{
	    return Equals(__lhs, __rhs);
	}

	public static bool operator!=(DbEnvDescriptor __lhs, DbEnvDescriptor __rhs)
	{
	    return !Equals(__lhs, __rhs);
	}

	#endregion

	#region Marshalling support

	public void __write(IceInternal.BasicStream __os)
	{
	    __os.writeString(name);
	    __os.writeString(dbHome);
	    __os.writeSize(properties.Length);
	    for(int __i = 0; __i < properties.Length; ++__i)
	    {
		properties[__i].__write(__os);
	    }
	}

	public void __read(IceInternal.BasicStream __is)
	{
	    name = __is.readString();
	    dbHome = __is.readString();
	    int sz = __is.readSize();
	    __is.startSeq(sz, 2);
	    properties = new IcePack.PropertyDescriptor[sz];
	    for(int __i = 0; __i < properties.Length; ++__i)
	    {
		properties[__i].__read(__is);
		__is.checkSeq();
		__is.endElement();
	    }
	}

	#endregion
    }

    public class ComponentDescriptor : Ice.ObjectImpl
    {
	#region Slice data members

	public string name;

	public IcePack.AdapterDescriptor[] adapters;

	public IcePack.PropertyDescriptor[] properties;

	public IcePack.DbEnvDescriptor[] dbEnvs;

	public string comment;

	#endregion // Slice data members

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::Ice::Object",
	    "::IcePack::ComponentDescriptor"
	};

	public override bool ice_isA(string s)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[1];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[1];
	}

	public static new string ice_staticId()
	{
	    return __ids[1];
	}

	#endregion

	#region Operation dispatch

	#endregion

	#region Marshaling support

	public override void __write(IceInternal.BasicStream __os)
	{
	    __os.writeTypeId(ice_staticId());
	    __os.startWriteSlice();
	    __os.writeString(name);
	    __os.writeSize(adapters.Length);
	    for(int __i = 0; __i < adapters.Length; ++__i)
	    {
		adapters[__i].__write(__os);
	    }
	    __os.writeSize(properties.Length);
	    for(int __i = 0; __i < properties.Length; ++__i)
	    {
		properties[__i].__write(__os);
	    }
	    __os.writeSize(dbEnvs.Length);
	    for(int __i = 0; __i < dbEnvs.Length; ++__i)
	    {
		dbEnvs[__i].__write(__os);
	    }
	    __os.writeString(comment);
	    __os.endWriteSlice();
	    base.__write(__os);
	}

	public override void __read(IceInternal.BasicStream __is, bool __rid)
	{
	    if(__rid)
	    {
		string myId = __is.readTypeId();
	    }
	    __is.startReadSlice();
	    name = __is.readString();
	    int sz = __is.readSize();
	    __is.startSeq(sz, 5);
	    adapters = new IcePack.AdapterDescriptor[sz];
	    for(int __i = 0; __i < adapters.Length; ++__i)
	    {
		adapters[__i].__read(__is);
		__is.checkSeq();
		__is.endElement();
	    }
	    int sz = __is.readSize();
	    __is.startSeq(sz, 2);
	    properties = new IcePack.PropertyDescriptor[sz];
	    for(int __i = 0; __i < properties.Length; ++__i)
	    {
		properties[__i].__read(__is);
		__is.checkSeq();
		__is.endElement();
	    }
	    int sz = __is.readSize();
	    __is.startSeq(sz, 3);
	    dbEnvs = new IcePack.DbEnvDescriptor[sz];
	    for(int __i = 0; __i < dbEnvs.Length; ++__i)
	    {
		dbEnvs[__i].__read(__is);
		__is.checkSeq();
		__is.endElement();
	    }
	    comment = __is.readString();
	    __is.endReadSlice();
	    base.__read(__is, true);
	}

	#endregion
    }

    public class ServerDescriptor : IcePack.ComponentDescriptor
    {
	#region Slice data members

	public string exe;

	public string pwd;

	public string node;

	public string application;

	public string[] options;

	public string[] envs;

	public IcePack.ServerActivation activation;

	#endregion // Slice data members

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::Ice::Object",
	    "::IcePack::ComponentDescriptor",
	    "::IcePack::ServerDescriptor"
	};

	public override bool ice_isA(string s)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[2];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[2];
	}

	public static new string ice_staticId()
	{
	    return __ids[2];
	}

	#endregion

	#region Operation dispatch

	#endregion

	#region Marshaling support

	public override void __write(IceInternal.BasicStream __os)
	{
	    __os.writeTypeId(ice_staticId());
	    __os.startWriteSlice();
	    __os.writeString(exe);
	    __os.writeString(pwd);
	    __os.writeString(node);
	    __os.writeString(application);
	    __os.writeStringSeq(options);
	    __os.writeStringSeq(envs);
	    __os.writeByte((byte)activation);
	    __os.endWriteSlice();
	    base.__write(__os);
	}

	public override void __read(IceInternal.BasicStream __is, bool __rid)
	{
	    if(__rid)
	    {
		string myId = __is.readTypeId();
	    }
	    __is.startReadSlice();
	    exe = __is.readString();
	    pwd = __is.readString();
	    node = __is.readString();
	    application = __is.readString();
	    options = __is.readStringSeq();
	    envs = __is.readStringSeq();
	    activation = (IcePack.ServerActivation)__is.readByte();
	    __is.endReadSlice();
	    base.__read(__is, true);
	}

	#endregion
    }

    public class JavaServerDescriptor : IcePack.ServerDescriptor
    {
	#region Slice data members

	public string className;

	public string[] jvmOptions;

	#endregion // Slice data members

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::Ice::Object",
	    "::IcePack::ComponentDescriptor",
	    "::IcePack::JavaServerDescriptor",
	    "::IcePack::ServerDescriptor"
	};

	public override bool ice_isA(string s)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[2];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[2];
	}

	public static new string ice_staticId()
	{
	    return __ids[2];
	}

	#endregion

	#region Operation dispatch

	#endregion

	#region Marshaling support

	public override void __write(IceInternal.BasicStream __os)
	{
	    __os.writeTypeId(ice_staticId());
	    __os.startWriteSlice();
	    __os.writeString(className);
	    __os.writeStringSeq(jvmOptions);
	    __os.endWriteSlice();
	    base.__write(__os);
	}

	public override void __read(IceInternal.BasicStream __is, bool __rid)
	{
	    if(__rid)
	    {
		string myId = __is.readTypeId();
	    }
	    __is.startReadSlice();
	    className = __is.readString();
	    jvmOptions = __is.readStringSeq();
	    __is.endReadSlice();
	    base.__read(__is, true);
	}

	#endregion
    }

    public class ServiceDescriptor : IcePack.ComponentDescriptor
    {
	#region Slice data members

	public string entry;

	#endregion // Slice data members

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::Ice::Object",
	    "::IcePack::ComponentDescriptor",
	    "::IcePack::ServiceDescriptor"
	};

	public override bool ice_isA(string s)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[2];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[2];
	}

	public static new string ice_staticId()
	{
	    return __ids[2];
	}

	#endregion

	#region Operation dispatch

	#endregion

	#region Marshaling support

	public override void __write(IceInternal.BasicStream __os)
	{
	    __os.writeTypeId(ice_staticId());
	    __os.startWriteSlice();
	    __os.writeString(entry);
	    __os.endWriteSlice();
	    base.__write(__os);
	}

	public override void __read(IceInternal.BasicStream __is, bool __rid)
	{
	    if(__rid)
	    {
		string myId = __is.readTypeId();
	    }
	    __is.startReadSlice();
	    entry = __is.readString();
	    __is.endReadSlice();
	    base.__read(__is, true);
	}

	#endregion
    }

    public class CppIceBoxDescriptor : IcePack.ServerDescriptor
    {
	#region Slice data members

	public IcePack.ServiceDescriptor[] services;

	public string endpoints;

	#endregion // Slice data members

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::Ice::Object",
	    "::IcePack::ComponentDescriptor",
	    "::IcePack::CppIceBoxDescriptor",
	    "::IcePack::ServerDescriptor"
	};

	public override bool ice_isA(string s)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[2];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[2];
	}

	public static new string ice_staticId()
	{
	    return __ids[2];
	}

	#endregion

	#region Operation dispatch

	#endregion

	#region Marshaling support

	public override void __write(IceInternal.BasicStream __os)
	{
	    __os.writeTypeId(ice_staticId());
	    __os.startWriteSlice();
	    __os.writeSize(services.Length);
	    for(int __i = 0; __i < services.Length; ++__i)
	    {
		__os.writeObject(services[__i]);
	    }
	    __os.writeString(endpoints);
	    __os.endWriteSlice();
	    base.__write(__os);
	}

	public override void __read(IceInternal.BasicStream __is, bool __rid)
	{
	    if(__rid)
	    {
		string myId = __is.readTypeId();
	    }
	    __is.startReadSlice();
	    int sz = __is.readSize();
	    __is.startSeq(sz, 4);
	    services = new 
	    services = new IcePack.ServiceDescriptor[sz];;
	    for(int i = 0; i < sz; ++i)
	    {
		IceInternal.SequencePatcher sp = new IceInternal.SequencePatcher(services, typeof(IcePack.ServiceDescriptor), i);
		__is.readObject(sp);
		__is.checkSeq();
		__is.endElement();
	    }
	    endpoints = __is.readString();
	    __is.endReadSlice();
	    base.__read(__is, true);
	}

	#endregion
    }

    public class JavaIceBoxDescriptor : IcePack.JavaServerDescriptor
    {
	#region Slice data members

	public IcePack.ServiceDescriptor[] services;

	public string endpoints;

	#endregion // Slice data members

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::Ice::Object",
	    "::IcePack::ComponentDescriptor",
	    "::IcePack::JavaIceBoxDescriptor",
	    "::IcePack::JavaServerDescriptor",
	    "::IcePack::ServerDescriptor"
	};

	public override bool ice_isA(string s)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[2];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[2];
	}

	public static new string ice_staticId()
	{
	    return __ids[2];
	}

	#endregion

	#region Operation dispatch

	#endregion

	#region Marshaling support

	public override void __write(IceInternal.BasicStream __os)
	{
	    __os.writeTypeId(ice_staticId());
	    __os.startWriteSlice();
	    __os.writeSize(services.Length);
	    for(int __i = 0; __i < services.Length; ++__i)
	    {
		__os.writeObject(services[__i]);
	    }
	    __os.writeString(endpoints);
	    __os.endWriteSlice();
	    base.__write(__os);
	}

	public override void __read(IceInternal.BasicStream __is, bool __rid)
	{
	    if(__rid)
	    {
		string myId = __is.readTypeId();
	    }
	    __is.startReadSlice();
	    int sz = __is.readSize();
	    __is.startSeq(sz, 4);
	    services = new 
	    services = new IcePack.ServiceDescriptor[sz];;
	    for(int i = 0; i < sz; ++i)
	    {
		IceInternal.SequencePatcher sp = new IceInternal.SequencePatcher(services, typeof(IcePack.ServiceDescriptor), i);
		__is.readObject(sp);
		__is.checkSeq();
		__is.endElement();
	    }
	    endpoints = __is.readString();
	    __is.endReadSlice();
	    base.__read(__is, true);
	}

	#endregion
    }

    public class ApplicationDescriptor : Ice.ObjectImpl
    {
	#region Slice data members

	public string name;

	public IcePack.ServerDescriptor[] servers;

	public string comment;

	#endregion // Slice data members

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::Ice::Object",
	    "::IcePack::ApplicationDescriptor"
	};

	public override bool ice_isA(string s)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[1];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[1];
	}

	public static new string ice_staticId()
	{
	    return __ids[1];
	}

	#endregion

	#region Operation dispatch

	#endregion

	#region Marshaling support

	public override void __write(IceInternal.BasicStream __os)
	{
	    __os.writeTypeId(ice_staticId());
	    __os.startWriteSlice();
	    __os.writeString(name);
	    __os.writeSize(servers.Length);
	    for(int __i = 0; __i < servers.Length; ++__i)
	    {
		__os.writeObject(servers[__i]);
	    }
	    __os.writeString(comment);
	    __os.endWriteSlice();
	    base.__write(__os);
	}

	public override void __read(IceInternal.BasicStream __is, bool __rid)
	{
	    if(__rid)
	    {
		string myId = __is.readTypeId();
	    }
	    __is.startReadSlice();
	    name = __is.readString();
	    int sz = __is.readSize();
	    __is.startSeq(sz, 4);
	    servers = new 
	    servers = new IcePack.ServerDescriptor[sz];;
	    for(int i = 0; i < sz; ++i)
	    {
		IceInternal.SequencePatcher sp = new IceInternal.SequencePatcher(servers, typeof(IcePack.ServerDescriptor), i);
		__is.readObject(sp);
		__is.checkSeq();
		__is.endElement();
	    }
	    comment = __is.readString();
	    __is.endReadSlice();
	    base.__read(__is, true);
	}

	#endregion
    }

    public enum ServerState
    {
	Inactive,
	Activating,
	Active,
	Deactivating,
	Destroying,
	Destroyed
    }

    public interface Admin : Ice.Object, _AdminOperations, _AdminOperationsNC
    {
    }
}

namespace IcePack
{
    public interface ComponentDescriptorPrx : Ice.ObjectPrx
    {
    }

    public interface ServerDescriptorPrx : IcePack.ComponentDescriptorPrx
    {
    }

    public interface JavaServerDescriptorPrx : IcePack.ServerDescriptorPrx
    {
    }

    public interface ServiceDescriptorPrx : IcePack.ComponentDescriptorPrx
    {
    }

    public interface CppIceBoxDescriptorPrx : IcePack.ServerDescriptorPrx
    {
    }

    public interface JavaIceBoxDescriptorPrx : IcePack.JavaServerDescriptorPrx
    {
    }

    public interface ApplicationDescriptorPrx : Ice.ObjectPrx
    {
    }

    public interface AdminPrx : Ice.ObjectPrx
    {
	void addApplication(IcePack.ApplicationDescriptor descriptor);
	void addApplication(IcePack.ApplicationDescriptor descriptor, Ice.Context __context);

	void updateApplication(IcePack.ApplicationDescriptor descriptor);
	void updateApplication(IcePack.ApplicationDescriptor descriptor, Ice.Context __context);

	string[] getAllApplicationNames();
	string[] getAllApplicationNames(Ice.Context __context);

	void removeApplication(string name);
	void removeApplication(string name, Ice.Context __context);

	IcePack.ApplicationDescriptor getApplicationDescriptor(string name);
	IcePack.ApplicationDescriptor getApplicationDescriptor(string name, Ice.Context __context);

	void addServer(IcePack.ServerDescriptor server);
	void addServer(IcePack.ServerDescriptor server, Ice.Context __context);

	void updateServer(IcePack.ServerDescriptor server);
	void updateServer(IcePack.ServerDescriptor server, Ice.Context __context);

	void removeServer(string name);
	void removeServer(string name, Ice.Context __context);

	IcePack.ServerDescriptor getServerDescriptor(string name);
	IcePack.ServerDescriptor getServerDescriptor(string name, Ice.Context __context);

	IcePack.ServerState getServerState(string name);
	IcePack.ServerState getServerState(string name, Ice.Context __context);

	int getServerPid(string name);
	int getServerPid(string name, Ice.Context __context);

	IcePack.ServerActivation getServerActivation(string name);
	IcePack.ServerActivation getServerActivation(string name, Ice.Context __context);

	void setServerActivation(string name, IcePack.ServerActivation mode);
	void setServerActivation(string name, IcePack.ServerActivation mode, Ice.Context __context);

	bool startServer(string name);
	bool startServer(string name, Ice.Context __context);

	void stopServer(string name);
	void stopServer(string name, Ice.Context __context);

	void sendSignal(string name, string signal);
	void sendSignal(string name, string signal, Ice.Context __context);

	void writeMessage(string name, string message, int fd);
	void writeMessage(string name, string message, int fd, Ice.Context __context);

	string[] getAllServerNames();
	string[] getAllServerNames(Ice.Context __context);

	string getAdapterEndpoints(string id);
	string getAdapterEndpoints(string id, Ice.Context __context);

	string[] getAllAdapterIds();
	string[] getAllAdapterIds(Ice.Context __context);

	void addObject(Ice.ObjectPrx obj);
	void addObject(Ice.ObjectPrx obj, Ice.Context __context);

	void addObjectWithType(Ice.ObjectPrx obj, string type);
	void addObjectWithType(Ice.ObjectPrx obj, string type, Ice.Context __context);

	void removeObject(Ice.ObjectPrx obj);
	void removeObject(Ice.ObjectPrx obj, Ice.Context __context);

	bool pingNode(string name);
	bool pingNode(string name, Ice.Context __context);

	void shutdownNode(string name);
	void shutdownNode(string name, Ice.Context __context);

	void removeNode(string name);
	void removeNode(string name, Ice.Context __context);

	string[] getAllNodeNames();
	string[] getAllNodeNames(Ice.Context __context);

	void shutdown();
	void shutdown(Ice.Context __context);

	Ice.SliceChecksumDict getSliceChecksums();
	Ice.SliceChecksumDict getSliceChecksums(Ice.Context __context);
    }
}

namespace IcePack
{
    public interface _AdminOperations
    {
	void addApplication(IcePack.ApplicationDescriptor descriptor, Ice.Current __current);

	void updateApplication(IcePack.ApplicationDescriptor descriptor, Ice.Current __current);

	string[] getAllApplicationNames(Ice.Current __current);

	void removeApplication(string name, Ice.Current __current);

	IcePack.ApplicationDescriptor getApplicationDescriptor(string name, Ice.Current __current);

	void addServer(IcePack.ServerDescriptor server, Ice.Current __current);

	void updateServer(IcePack.ServerDescriptor server, Ice.Current __current);

	void removeServer(string name, Ice.Current __current);

	IcePack.ServerDescriptor getServerDescriptor(string name, Ice.Current __current);

	IcePack.ServerState getServerState(string name, Ice.Current __current);

	int getServerPid(string name, Ice.Current __current);

	IcePack.ServerActivation getServerActivation(string name, Ice.Current __current);

	void setServerActivation(string name, IcePack.ServerActivation mode, Ice.Current __current);

	bool startServer(string name, Ice.Current __current);

	void stopServer(string name, Ice.Current __current);

	void sendSignal(string name, string signal, Ice.Current __current);

	void writeMessage(string name, string message, int fd, Ice.Current __current);

	string[] getAllServerNames(Ice.Current __current);

	string getAdapterEndpoints(string id, Ice.Current __current);

	string[] getAllAdapterIds(Ice.Current __current);

	void addObject(Ice.ObjectPrx obj, Ice.Current __current);

	void addObjectWithType(Ice.ObjectPrx obj, string type, Ice.Current __current);

	void removeObject(Ice.ObjectPrx obj, Ice.Current __current);

	bool pingNode(string name, Ice.Current __current);

	void shutdownNode(string name, Ice.Current __current);

	void removeNode(string name, Ice.Current __current);

	string[] getAllNodeNames(Ice.Current __current);

	void shutdown(Ice.Current __current);

	Ice.SliceChecksumDict getSliceChecksums(Ice.Current __current);
    }

    public interface _AdminOperationsNC
    {
	void addApplication(IcePack.ApplicationDescriptor descriptor);

	void updateApplication(IcePack.ApplicationDescriptor descriptor);

	string[] getAllApplicationNames();

	void removeApplication(string name);

	IcePack.ApplicationDescriptor getApplicationDescriptor(string name);

	void addServer(IcePack.ServerDescriptor server);

	void updateServer(IcePack.ServerDescriptor server);

	void removeServer(string name);

	IcePack.ServerDescriptor getServerDescriptor(string name);

	IcePack.ServerState getServerState(string name);

	int getServerPid(string name);

	IcePack.ServerActivation getServerActivation(string name);

	void setServerActivation(string name, IcePack.ServerActivation mode);

	bool startServer(string name);

	void stopServer(string name);

	void sendSignal(string name, string signal);

	void writeMessage(string name, string message, int fd);

	string[] getAllServerNames();

	string getAdapterEndpoints(string id);

	string[] getAllAdapterIds();

	void addObject(Ice.ObjectPrx obj);

	void addObjectWithType(Ice.ObjectPrx obj, string type);

	void removeObject(Ice.ObjectPrx obj);

	bool pingNode(string name);

	void shutdownNode(string name);

	void removeNode(string name);

	string[] getAllNodeNames();

	void shutdown();

	Ice.SliceChecksumDict getSliceChecksums();
    }
}

namespace IcePack
{
    public sealed class ObjectDescriptorSeqHelper
    {
	public static void write(IceInternal.BasicStream __os, IcePack.ObjectDescriptor[] __v)
	{
	    __os.writeSize(__v.Length);
	    for(int __i = 0; __i < __v.Length; ++__i)
	    {
		__v[__i].__write(__os);
	    }
	}

	public static IcePack.ObjectDescriptor[] read(IceInternal.BasicStream __is)
	{
	    IcePack.ObjectDescriptor[] __v;
	    int sz = __is.readSize();
	    __is.startSeq(sz, 4);
	    __v = new IcePack.ObjectDescriptor[sz];
	    for(int __i = 0; __i < __v.Length; ++__i)
	    {
		__v[__i].__read(__is);
		__is.checkSeq();
		__is.endElement();
	    }
	    return __v;
	}
    }

    public sealed class AdapterDescriptorSeqHelper
    {
	public static void write(IceInternal.BasicStream __os, IcePack.AdapterDescriptor[] __v)
	{
	    __os.writeSize(__v.Length);
	    for(int __i = 0; __i < __v.Length; ++__i)
	    {
		__v[__i].__write(__os);
	    }
	}

	public static IcePack.AdapterDescriptor[] read(IceInternal.BasicStream __is)
	{
	    IcePack.AdapterDescriptor[] __v;
	    int sz = __is.readSize();
	    __is.startSeq(sz, 5);
	    __v = new IcePack.AdapterDescriptor[sz];
	    for(int __i = 0; __i < __v.Length; ++__i)
	    {
		__v[__i].__read(__is);
		__is.checkSeq();
		__is.endElement();
	    }
	    return __v;
	}
    }

    public sealed class PropertyDescriptorSeqHelper
    {
	public static void write(IceInternal.BasicStream __os, IcePack.PropertyDescriptor[] __v)
	{
	    __os.writeSize(__v.Length);
	    for(int __i = 0; __i < __v.Length; ++__i)
	    {
		__v[__i].__write(__os);
	    }
	}

	public static IcePack.PropertyDescriptor[] read(IceInternal.BasicStream __is)
	{
	    IcePack.PropertyDescriptor[] __v;
	    int sz = __is.readSize();
	    __is.startSeq(sz, 2);
	    __v = new IcePack.PropertyDescriptor[sz];
	    for(int __i = 0; __i < __v.Length; ++__i)
	    {
		__v[__i].__read(__is);
		__is.checkSeq();
		__is.endElement();
	    }
	    return __v;
	}
    }

    public sealed class DbEnvDescriptorSeqHelper
    {
	public static void write(IceInternal.BasicStream __os, IcePack.DbEnvDescriptor[] __v)
	{
	    __os.writeSize(__v.Length);
	    for(int __i = 0; __i < __v.Length; ++__i)
	    {
		__v[__i].__write(__os);
	    }
	}

	public static IcePack.DbEnvDescriptor[] read(IceInternal.BasicStream __is)
	{
	    IcePack.DbEnvDescriptor[] __v;
	    int sz = __is.readSize();
	    __is.startSeq(sz, 3);
	    __v = new IcePack.DbEnvDescriptor[sz];
	    for(int __i = 0; __i < __v.Length; ++__i)
	    {
		__v[__i].__read(__is);
		__is.checkSeq();
		__is.endElement();
	    }
	    return __v;
	}
    }

    public class ComponentDescriptorPrxHelper : Ice.ObjectPrxHelperBase, ComponentDescriptorPrx
    {
	#region Checked and unchecked cast operations

	public static ComponentDescriptorPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is ComponentDescriptorPrx)
	    {
		return (ComponentDescriptorPrx)b;
	    }
	    if(b.ice_isA("::IcePack::ComponentDescriptor"))
	    {
		ComponentDescriptorPrxHelper h = new ComponentDescriptorPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static ComponentDescriptorPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::IcePack::ComponentDescriptor"))
		{
		    ComponentDescriptorPrxHelper h = new ComponentDescriptorPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static ComponentDescriptorPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    ComponentDescriptorPrxHelper h = new ComponentDescriptorPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static ComponentDescriptorPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    ComponentDescriptorPrxHelper h = new ComponentDescriptorPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _ComponentDescriptorDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _ComponentDescriptorDelD();
	}

	public static void __write(IceInternal.BasicStream __os, ComponentDescriptorPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static ComponentDescriptorPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		ComponentDescriptorPrxHelper result = new ComponentDescriptorPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public class ServerDescriptorPrxHelper : Ice.ObjectPrxHelperBase, ServerDescriptorPrx
    {
	#region Checked and unchecked cast operations

	public static ServerDescriptorPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is ServerDescriptorPrx)
	    {
		return (ServerDescriptorPrx)b;
	    }
	    if(b.ice_isA("::IcePack::ServerDescriptor"))
	    {
		ServerDescriptorPrxHelper h = new ServerDescriptorPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static ServerDescriptorPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::IcePack::ServerDescriptor"))
		{
		    ServerDescriptorPrxHelper h = new ServerDescriptorPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static ServerDescriptorPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    ServerDescriptorPrxHelper h = new ServerDescriptorPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static ServerDescriptorPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    ServerDescriptorPrxHelper h = new ServerDescriptorPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _ServerDescriptorDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _ServerDescriptorDelD();
	}

	public static void __write(IceInternal.BasicStream __os, ServerDescriptorPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static ServerDescriptorPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		ServerDescriptorPrxHelper result = new ServerDescriptorPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public sealed class ServerDescriptorSeqHelper
    {
	public static void write(IceInternal.BasicStream __os, IcePack.ServerDescriptor[] __v)
	{
	    __os.writeSize(__v.Length);
	    for(int __i = 0; __i < __v.Length; ++__i)
	    {
		__os.writeObject(__v[__i]);
	    }
	}

	public static IcePack.ServerDescriptor[] read(IceInternal.BasicStream __is)
	{
	    IcePack.ServerDescriptor[] __v;
	    int sz = __is.readSize();
	    __is.startSeq(sz, 4);
	    __v = new 
	    __v = new IcePack.ServerDescriptor[sz];;
	    for(int i = 0; i < sz; ++i)
	    {
		IceInternal.SequencePatcher sp = new IceInternal.SequencePatcher(__v, typeof(IcePack.ServerDescriptor), i);
		__is.readObject(sp);
		__is.checkSeq();
		__is.endElement();
	    }
	    return __v;
	}
    }

    public class JavaServerDescriptorPrxHelper : Ice.ObjectPrxHelperBase, JavaServerDescriptorPrx
    {
	#region Checked and unchecked cast operations

	public static JavaServerDescriptorPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is JavaServerDescriptorPrx)
	    {
		return (JavaServerDescriptorPrx)b;
	    }
	    if(b.ice_isA("::IcePack::JavaServerDescriptor"))
	    {
		JavaServerDescriptorPrxHelper h = new JavaServerDescriptorPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static JavaServerDescriptorPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::IcePack::JavaServerDescriptor"))
		{
		    JavaServerDescriptorPrxHelper h = new JavaServerDescriptorPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static JavaServerDescriptorPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    JavaServerDescriptorPrxHelper h = new JavaServerDescriptorPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static JavaServerDescriptorPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    JavaServerDescriptorPrxHelper h = new JavaServerDescriptorPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _JavaServerDescriptorDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _JavaServerDescriptorDelD();
	}

	public static void __write(IceInternal.BasicStream __os, JavaServerDescriptorPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static JavaServerDescriptorPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		JavaServerDescriptorPrxHelper result = new JavaServerDescriptorPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public class ServiceDescriptorPrxHelper : Ice.ObjectPrxHelperBase, ServiceDescriptorPrx
    {
	#region Checked and unchecked cast operations

	public static ServiceDescriptorPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is ServiceDescriptorPrx)
	    {
		return (ServiceDescriptorPrx)b;
	    }
	    if(b.ice_isA("::IcePack::ServiceDescriptor"))
	    {
		ServiceDescriptorPrxHelper h = new ServiceDescriptorPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static ServiceDescriptorPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::IcePack::ServiceDescriptor"))
		{
		    ServiceDescriptorPrxHelper h = new ServiceDescriptorPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static ServiceDescriptorPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    ServiceDescriptorPrxHelper h = new ServiceDescriptorPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static ServiceDescriptorPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    ServiceDescriptorPrxHelper h = new ServiceDescriptorPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _ServiceDescriptorDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _ServiceDescriptorDelD();
	}

	public static void __write(IceInternal.BasicStream __os, ServiceDescriptorPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static ServiceDescriptorPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		ServiceDescriptorPrxHelper result = new ServiceDescriptorPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public sealed class ServiceDescriptorSeqHelper
    {
	public static void write(IceInternal.BasicStream __os, IcePack.ServiceDescriptor[] __v)
	{
	    __os.writeSize(__v.Length);
	    for(int __i = 0; __i < __v.Length; ++__i)
	    {
		__os.writeObject(__v[__i]);
	    }
	}

	public static IcePack.ServiceDescriptor[] read(IceInternal.BasicStream __is)
	{
	    IcePack.ServiceDescriptor[] __v;
	    int sz = __is.readSize();
	    __is.startSeq(sz, 4);
	    __v = new 
	    __v = new IcePack.ServiceDescriptor[sz];;
	    for(int i = 0; i < sz; ++i)
	    {
		IceInternal.SequencePatcher sp = new IceInternal.SequencePatcher(__v, typeof(IcePack.ServiceDescriptor), i);
		__is.readObject(sp);
		__is.checkSeq();
		__is.endElement();
	    }
	    return __v;
	}
    }

    public class CppIceBoxDescriptorPrxHelper : Ice.ObjectPrxHelperBase, CppIceBoxDescriptorPrx
    {
	#region Checked and unchecked cast operations

	public static CppIceBoxDescriptorPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is CppIceBoxDescriptorPrx)
	    {
		return (CppIceBoxDescriptorPrx)b;
	    }
	    if(b.ice_isA("::IcePack::CppIceBoxDescriptor"))
	    {
		CppIceBoxDescriptorPrxHelper h = new CppIceBoxDescriptorPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static CppIceBoxDescriptorPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::IcePack::CppIceBoxDescriptor"))
		{
		    CppIceBoxDescriptorPrxHelper h = new CppIceBoxDescriptorPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static CppIceBoxDescriptorPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    CppIceBoxDescriptorPrxHelper h = new CppIceBoxDescriptorPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static CppIceBoxDescriptorPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    CppIceBoxDescriptorPrxHelper h = new CppIceBoxDescriptorPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _CppIceBoxDescriptorDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _CppIceBoxDescriptorDelD();
	}

	public static void __write(IceInternal.BasicStream __os, CppIceBoxDescriptorPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static CppIceBoxDescriptorPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		CppIceBoxDescriptorPrxHelper result = new CppIceBoxDescriptorPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public class JavaIceBoxDescriptorPrxHelper : Ice.ObjectPrxHelperBase, JavaIceBoxDescriptorPrx
    {
	#region Checked and unchecked cast operations

	public static JavaIceBoxDescriptorPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is JavaIceBoxDescriptorPrx)
	    {
		return (JavaIceBoxDescriptorPrx)b;
	    }
	    if(b.ice_isA("::IcePack::JavaIceBoxDescriptor"))
	    {
		JavaIceBoxDescriptorPrxHelper h = new JavaIceBoxDescriptorPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static JavaIceBoxDescriptorPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::IcePack::JavaIceBoxDescriptor"))
		{
		    JavaIceBoxDescriptorPrxHelper h = new JavaIceBoxDescriptorPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static JavaIceBoxDescriptorPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    JavaIceBoxDescriptorPrxHelper h = new JavaIceBoxDescriptorPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static JavaIceBoxDescriptorPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    JavaIceBoxDescriptorPrxHelper h = new JavaIceBoxDescriptorPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _JavaIceBoxDescriptorDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _JavaIceBoxDescriptorDelD();
	}

	public static void __write(IceInternal.BasicStream __os, JavaIceBoxDescriptorPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static JavaIceBoxDescriptorPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		JavaIceBoxDescriptorPrxHelper result = new JavaIceBoxDescriptorPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public class ApplicationDescriptorPrxHelper : Ice.ObjectPrxHelperBase, ApplicationDescriptorPrx
    {
	#region Checked and unchecked cast operations

	public static ApplicationDescriptorPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is ApplicationDescriptorPrx)
	    {
		return (ApplicationDescriptorPrx)b;
	    }
	    if(b.ice_isA("::IcePack::ApplicationDescriptor"))
	    {
		ApplicationDescriptorPrxHelper h = new ApplicationDescriptorPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static ApplicationDescriptorPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::IcePack::ApplicationDescriptor"))
		{
		    ApplicationDescriptorPrxHelper h = new ApplicationDescriptorPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static ApplicationDescriptorPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    ApplicationDescriptorPrxHelper h = new ApplicationDescriptorPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static ApplicationDescriptorPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    ApplicationDescriptorPrxHelper h = new ApplicationDescriptorPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _ApplicationDescriptorDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _ApplicationDescriptorDelD();
	}

	public static void __write(IceInternal.BasicStream __os, ApplicationDescriptorPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static ApplicationDescriptorPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		ApplicationDescriptorPrxHelper result = new ApplicationDescriptorPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public class AdminPrxHelper : Ice.ObjectPrxHelperBase, AdminPrx
    {
	#region Synchronous operations

	public void addApplication(IcePack.ApplicationDescriptor descriptor)
	{
	    addApplication(descriptor, __defaultContext());
	}

	public void addApplication(IcePack.ApplicationDescriptor descriptor, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("addApplication");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.addApplication(descriptor, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void addObject(Ice.ObjectPrx obj)
	{
	    addObject(obj, __defaultContext());
	}

	public void addObject(Ice.ObjectPrx obj, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("addObject");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.addObject(obj, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void addObjectWithType(Ice.ObjectPrx obj, string type)
	{
	    addObjectWithType(obj, type, __defaultContext());
	}

	public void addObjectWithType(Ice.ObjectPrx obj, string type, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("addObjectWithType");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.addObjectWithType(obj, type, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void addServer(IcePack.ServerDescriptor server)
	{
	    addServer(server, __defaultContext());
	}

	public void addServer(IcePack.ServerDescriptor server, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("addServer");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.addServer(server, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public string getAdapterEndpoints(string id)
	{
	    return getAdapterEndpoints(id, __defaultContext());
	}

	public string getAdapterEndpoints(string id, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getAdapterEndpoints");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.getAdapterEndpoints(id, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public string[] getAllAdapterIds()
	{
	    return getAllAdapterIds(__defaultContext());
	}

	public string[] getAllAdapterIds(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getAllAdapterIds");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.getAllAdapterIds(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public string[] getAllApplicationNames()
	{
	    return getAllApplicationNames(__defaultContext());
	}

	public string[] getAllApplicationNames(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getAllApplicationNames");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.getAllApplicationNames(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public string[] getAllNodeNames()
	{
	    return getAllNodeNames(__defaultContext());
	}

	public string[] getAllNodeNames(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getAllNodeNames");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.getAllNodeNames(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public string[] getAllServerNames()
	{
	    return getAllServerNames(__defaultContext());
	}

	public string[] getAllServerNames(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getAllServerNames");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.getAllServerNames(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public IcePack.ApplicationDescriptor getApplicationDescriptor(string name)
	{
	    return getApplicationDescriptor(name, __defaultContext());
	}

	public IcePack.ApplicationDescriptor getApplicationDescriptor(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getApplicationDescriptor");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.getApplicationDescriptor(name, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public IcePack.ServerActivation getServerActivation(string name)
	{
	    return getServerActivation(name, __defaultContext());
	}

	public IcePack.ServerActivation getServerActivation(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getServerActivation");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.getServerActivation(name, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public IcePack.ServerDescriptor getServerDescriptor(string name)
	{
	    return getServerDescriptor(name, __defaultContext());
	}

	public IcePack.ServerDescriptor getServerDescriptor(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getServerDescriptor");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.getServerDescriptor(name, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public int getServerPid(string name)
	{
	    return getServerPid(name, __defaultContext());
	}

	public int getServerPid(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getServerPid");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.getServerPid(name, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public IcePack.ServerState getServerState(string name)
	{
	    return getServerState(name, __defaultContext());
	}

	public IcePack.ServerState getServerState(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getServerState");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.getServerState(name, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public Ice.SliceChecksumDict getSliceChecksums()
	{
	    return getSliceChecksums(__defaultContext());
	}

	public Ice.SliceChecksumDict getSliceChecksums(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("getSliceChecksums");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.getSliceChecksums(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public bool pingNode(string name)
	{
	    return pingNode(name, __defaultContext());
	}

	public bool pingNode(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("pingNode");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.pingNode(name, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void removeApplication(string name)
	{
	    removeApplication(name, __defaultContext());
	}

	public void removeApplication(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("removeApplication");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.removeApplication(name, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void removeNode(string name)
	{
	    removeNode(name, __defaultContext());
	}

	public void removeNode(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("removeNode");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.removeNode(name, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void removeObject(Ice.ObjectPrx obj)
	{
	    removeObject(obj, __defaultContext());
	}

	public void removeObject(Ice.ObjectPrx obj, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("removeObject");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.removeObject(obj, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void removeServer(string name)
	{
	    removeServer(name, __defaultContext());
	}

	public void removeServer(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("removeServer");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.removeServer(name, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void sendSignal(string name, string signal)
	{
	    sendSignal(name, signal, __defaultContext());
	}

	public void sendSignal(string name, string signal, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("sendSignal");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.sendSignal(name, signal, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void setServerActivation(string name, IcePack.ServerActivation mode)
	{
	    setServerActivation(name, mode, __defaultContext());
	}

	public void setServerActivation(string name, IcePack.ServerActivation mode, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("setServerActivation");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.setServerActivation(name, mode, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void shutdown()
	{
	    shutdown(__defaultContext());
	}

	public void shutdown(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.shutdown(__context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void shutdownNode(string name)
	{
	    shutdownNode(name, __defaultContext());
	}

	public void shutdownNode(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("shutdownNode");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.shutdownNode(name, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __cnt = __handleException(__ex.get(), __cnt);
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public bool startServer(string name)
	{
	    return startServer(name, __defaultContext());
	}

	public bool startServer(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("startServer");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    return __del.startServer(name, __context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void stopServer(string name)
	{
	    stopServer(name, __defaultContext());
	}

	public void stopServer(string name, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("stopServer");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.stopServer(name, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void updateApplication(IcePack.ApplicationDescriptor descriptor)
	{
	    updateApplication(descriptor, __defaultContext());
	}

	public void updateApplication(IcePack.ApplicationDescriptor descriptor, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("updateApplication");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.updateApplication(descriptor, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void updateServer(IcePack.ServerDescriptor server)
	{
	    updateServer(server, __defaultContext());
	}

	public void updateServer(IcePack.ServerDescriptor server, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("updateServer");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.updateServer(server, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	public void writeMessage(string name, string message, int fd)
	{
	    writeMessage(name, message, fd, __defaultContext());
	}

	public void writeMessage(string name, string message, int fd, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("writeMessage");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _AdminDel __del = (_AdminDel)__delBase;
		    __del.writeMessage(name, message, fd, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	#endregion

	#region Asynchronous operations

	#endregion

	#region Checked and unchecked cast operations

	public static AdminPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is AdminPrx)
	    {
		return (AdminPrx)b;
	    }
	    if(b.ice_isA("::IcePack::Admin"))
	    {
		AdminPrxHelper h = new AdminPrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static AdminPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::IcePack::Admin"))
		{
		    AdminPrxHelper h = new AdminPrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static AdminPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    AdminPrxHelper h = new AdminPrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static AdminPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    AdminPrxHelper h = new AdminPrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _AdminDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _AdminDelD();
	}

	public static void __write(IceInternal.BasicStream __os, AdminPrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static AdminPrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		AdminPrxHelper result = new AdminPrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }
}

namespace IcePack
{
    public interface _ComponentDescriptorDel : Ice._ObjectDel
    {
    }

    public interface _ServerDescriptorDel : IcePack._ComponentDescriptorDel
    {
    }

    public interface _JavaServerDescriptorDel : IcePack._ServerDescriptorDel
    {
    }

    public interface _ServiceDescriptorDel : IcePack._ComponentDescriptorDel
    {
    }

    public interface _CppIceBoxDescriptorDel : IcePack._ServerDescriptorDel
    {
    }

    public interface _JavaIceBoxDescriptorDel : IcePack._JavaServerDescriptorDel
    {
    }

    public interface _ApplicationDescriptorDel : Ice._ObjectDel
    {
    }

    public interface _AdminDel : Ice._ObjectDel
    {
	void addApplication(IcePack.ApplicationDescriptor descriptor, Ice.Context __context);

	void updateApplication(IcePack.ApplicationDescriptor descriptor, Ice.Context __context);

	string[] getAllApplicationNames(Ice.Context __context);

	void removeApplication(string name, Ice.Context __context);

	IcePack.ApplicationDescriptor getApplicationDescriptor(string name, Ice.Context __context);

	void addServer(IcePack.ServerDescriptor server, Ice.Context __context);

	void updateServer(IcePack.ServerDescriptor server, Ice.Context __context);

	void removeServer(string name, Ice.Context __context);

	IcePack.ServerDescriptor getServerDescriptor(string name, Ice.Context __context);

	IcePack.ServerState getServerState(string name, Ice.Context __context);

	int getServerPid(string name, Ice.Context __context);

	IcePack.ServerActivation getServerActivation(string name, Ice.Context __context);

	void setServerActivation(string name, IcePack.ServerActivation mode, Ice.Context __context);

	bool startServer(string name, Ice.Context __context);

	void stopServer(string name, Ice.Context __context);

	void sendSignal(string name, string signal, Ice.Context __context);

	void writeMessage(string name, string message, int fd, Ice.Context __context);

	string[] getAllServerNames(Ice.Context __context);

	string getAdapterEndpoints(string id, Ice.Context __context);

	string[] getAllAdapterIds(Ice.Context __context);

	void addObject(Ice.ObjectPrx obj, Ice.Context __context);

	void addObjectWithType(Ice.ObjectPrx obj, string type, Ice.Context __context);

	void removeObject(Ice.ObjectPrx obj, Ice.Context __context);

	bool pingNode(string name, Ice.Context __context);

	void shutdownNode(string name, Ice.Context __context);

	void removeNode(string name, Ice.Context __context);

	string[] getAllNodeNames(Ice.Context __context);

	void shutdown(Ice.Context __context);

	Ice.SliceChecksumDict getSliceChecksums(Ice.Context __context);
    }
}

namespace IcePack
{
    public sealed class _ComponentDescriptorDelM : Ice._ObjectDelM, _ComponentDescriptorDel
    {
    }

    public sealed class _ServerDescriptorDelM : Ice._ObjectDelM, _ServerDescriptorDel
    {
    }

    public sealed class _JavaServerDescriptorDelM : Ice._ObjectDelM, _JavaServerDescriptorDel
    {
    }

    public sealed class _ServiceDescriptorDelM : Ice._ObjectDelM, _ServiceDescriptorDel
    {
    }

    public sealed class _CppIceBoxDescriptorDelM : Ice._ObjectDelM, _CppIceBoxDescriptorDel
    {
    }

    public sealed class _JavaIceBoxDescriptorDelM : Ice._ObjectDelM, _JavaIceBoxDescriptorDel
    {
    }

    public sealed class _ApplicationDescriptorDelM : Ice._ObjectDelM, _ApplicationDescriptorDel
    {
    }

    public sealed class _AdminDelM : Ice._ObjectDelM, _AdminDel
    {
	public void addApplication(IcePack.ApplicationDescriptor descriptor, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("addApplication", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeObject(descriptor);
		__os.writePendingObjects();
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(DeploymentException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void addObject(Ice.ObjectPrx obj, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("addObject", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeProxy(obj);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(DeploymentException)
		    {
			throw;
		    }
		    catch(ObjectExistsException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void addObjectWithType(Ice.ObjectPrx obj, string type, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("addObjectWithType", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeProxy(obj);
		__os.writeString(type);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(ObjectExistsException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void addServer(IcePack.ServerDescriptor server, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("addServer", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeObject(server);
		__os.writePendingObjects();
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(DeploymentException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public string getAdapterEndpoints(string id, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getAdapterEndpoints", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(id);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(AdapterNotExistException)
		    {
			throw;
		    }
		    catch(NodeUnreachableException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    string __ret;
		    __ret = __is.readString();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public string[] getAllAdapterIds(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getAllAdapterIds", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    string[] __ret;
		    __ret = __is.readStringSeq();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public string[] getAllApplicationNames(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getAllApplicationNames", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    string[] __ret;
		    __ret = __is.readStringSeq();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public string[] getAllNodeNames(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getAllNodeNames", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    string[] __ret;
		    __ret = __is.readStringSeq();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public string[] getAllServerNames(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getAllServerNames", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    string[] __ret;
		    __ret = __is.readStringSeq();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public IcePack.ApplicationDescriptor getApplicationDescriptor(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getApplicationDescriptor", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(ApplicationNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    IcePack.ApplicationDescriptor __ret;
		    IceInternal.ParamPatcher __ret_PP = new IceInternal.ParamPatcher(typeof(IcePack.ApplicationDescriptor));
		    __is.readObject(__ret_PP);
		    __is.readPendingObjects();
		    __ret = (IcePack.ApplicationDescriptor)__ret_PP.value;
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public IcePack.ServerActivation getServerActivation(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getServerActivation", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(NodeUnreachableException)
		    {
			throw;
		    }
		    catch(ServerNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    IcePack.ServerActivation __ret;
		    __ret = (IcePack.ServerActivation)__is.readByte();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public IcePack.ServerDescriptor getServerDescriptor(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getServerDescriptor", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(ServerNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    IcePack.ServerDescriptor __ret;
		    IceInternal.ParamPatcher __ret_PP = new IceInternal.ParamPatcher(typeof(IcePack.ServerDescriptor));
		    __is.readObject(__ret_PP);
		    __is.readPendingObjects();
		    __ret = (IcePack.ServerDescriptor)__ret_PP.value;
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public int getServerPid(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getServerPid", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(NodeUnreachableException)
		    {
			throw;
		    }
		    catch(ServerNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    int __ret;
		    __ret = __is.readInt();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public IcePack.ServerState getServerState(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getServerState", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(NodeUnreachableException)
		    {
			throw;
		    }
		    catch(ServerNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    IcePack.ServerState __ret;
		    __ret = (IcePack.ServerState)__is.readByte();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public Ice.SliceChecksumDict getSliceChecksums(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("getSliceChecksums", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __out.istr();
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    Ice.SliceChecksumDict __ret;
		    __ret = Ice.SliceChecksumDictHelper.read(__is);
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public bool pingNode(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("pingNode", Ice.OperationMode.Nonmutating, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(NodeNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    bool __ret;
		    __ret = __is.readBool();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void removeApplication(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("removeApplication", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(ApplicationNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void removeNode(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("removeNode", Ice.OperationMode.Idempotent, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(NodeNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void removeObject(Ice.ObjectPrx obj, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("removeObject", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeProxy(obj);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(ObjectNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void removeServer(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("removeServer", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(DeploymentException)
		    {
			throw;
		    }
		    catch(ServerNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void sendSignal(string name, string signal, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("sendSignal", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		__os.writeString(signal);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(BadSignalException)
		    {
			throw;
		    }
		    catch(NodeUnreachableException)
		    {
			throw;
		    }
		    catch(ServerNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void setServerActivation(string name, IcePack.ServerActivation mode, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("setServerActivation", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		__os.writeByte((byte)mode);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(NodeUnreachableException)
		    {
			throw;
		    }
		    catch(ServerNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void shutdown(Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("shutdown", Ice.OperationMode.Idempotent, __context, __compress);
	    try
	    {
		if(!__out.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void shutdownNode(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("shutdownNode", Ice.OperationMode.Idempotent, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(NodeNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public bool startServer(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("startServer", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(NodeUnreachableException)
		    {
			throw;
		    }
		    catch(ServerNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    bool __ret;
		    __ret = __is.readBool();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void stopServer(string name, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("stopServer", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(NodeUnreachableException)
		    {
			throw;
		    }
		    catch(ServerNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void updateApplication(IcePack.ApplicationDescriptor descriptor, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("updateApplication", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeObject(descriptor);
		__os.writePendingObjects();
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(DeploymentException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void updateServer(IcePack.ServerDescriptor server, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("updateServer", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeObject(server);
		__os.writePendingObjects();
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(DeploymentException)
		    {
			throw;
		    }
		    catch(ServerNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}

	public void writeMessage(string name, string message, int fd, Ice.Context __context)
	{
	    IceInternal.Outgoing __out = getOutgoing("writeMessage", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __os = __out.ostr();
		IceInternal.BasicStream __is = __out.istr();
		__os.writeString(name);
		__os.writeString(message);
		__os.writeInt(fd);
		if(!__out.invoke())
		{
		    try
		    {
			__is.throwException();
		    }
		    catch(NodeUnreachableException)
		    {
			throw;
		    }
		    catch(ServerNotExistException)
		    {
			throw;
		    }
		    catch(Ice.UserException)
		    {
		    }
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__out);
	    }
	}
    }
}

namespace IcePack
{
    public sealed class _ComponentDescriptorDelD : Ice._ObjectDelD, _ComponentDescriptorDel
    {
    }

    public sealed class _ServerDescriptorDelD : Ice._ObjectDelD, _ServerDescriptorDel
    {
    }

    public sealed class _JavaServerDescriptorDelD : Ice._ObjectDelD, _JavaServerDescriptorDel
    {
    }

    public sealed class _ServiceDescriptorDelD : Ice._ObjectDelD, _ServiceDescriptorDel
    {
    }

    public sealed class _CppIceBoxDescriptorDelD : Ice._ObjectDelD, _CppIceBoxDescriptorDel
    {
    }

    public sealed class _JavaIceBoxDescriptorDelD : Ice._ObjectDelD, _JavaIceBoxDescriptorDel
    {
    }

    public sealed class _ApplicationDescriptorDelD : Ice._ObjectDelD, _ApplicationDescriptorDel
    {
    }

    public sealed class _AdminDelD : Ice._ObjectDelD, _AdminDel
    {
	public void addApplication(IcePack.ApplicationDescriptor descriptor, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "addApplication", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).addApplication(descriptor, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void addObject(Ice.ObjectPrx obj, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "addObject", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).addObject(obj, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void addObjectWithType(Ice.ObjectPrx obj, string type, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "addObjectWithType", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).addObjectWithType(obj, type, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void addServer(IcePack.ServerDescriptor server, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "addServer", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).addServer(server, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public string getAdapterEndpoints(string id, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getAdapterEndpoints", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).getAdapterEndpoints(id, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public string[] getAllAdapterIds(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getAllAdapterIds", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).getAllAdapterIds(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public string[] getAllApplicationNames(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getAllApplicationNames", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).getAllApplicationNames(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public string[] getAllNodeNames(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getAllNodeNames", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).getAllNodeNames(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public string[] getAllServerNames(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getAllServerNames", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).getAllServerNames(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public IcePack.ApplicationDescriptor getApplicationDescriptor(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getApplicationDescriptor", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).getApplicationDescriptor(name, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public IcePack.ServerActivation getServerActivation(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getServerActivation", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).getServerActivation(name, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public IcePack.ServerDescriptor getServerDescriptor(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getServerDescriptor", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).getServerDescriptor(name, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public int getServerPid(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getServerPid", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).getServerPid(name, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public IcePack.ServerState getServerState(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getServerState", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).getServerState(name, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public Ice.SliceChecksumDict getSliceChecksums(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "getSliceChecksums", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).getSliceChecksums(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public bool pingNode(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "pingNode", Ice.OperationMode.Nonmutating, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).pingNode(name, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void removeApplication(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "removeApplication", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).removeApplication(name, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void removeNode(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "removeNode", Ice.OperationMode.Idempotent, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).removeNode(name, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void removeObject(Ice.ObjectPrx obj, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "removeObject", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).removeObject(obj, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void removeServer(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "removeServer", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).removeServer(name, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void sendSignal(string name, string signal, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "sendSignal", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).sendSignal(name, signal, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void setServerActivation(string name, IcePack.ServerActivation mode, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "setServerActivation", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).setServerActivation(name, mode, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void shutdown(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "shutdown", Ice.OperationMode.Idempotent, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).shutdown(__current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void shutdownNode(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "shutdownNode", Ice.OperationMode.Idempotent, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).shutdownNode(name, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public bool startServer(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "startServer", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			return ((Admin)__servant).startServer(name, __current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void stopServer(string name, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "stopServer", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).stopServer(name, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void updateApplication(IcePack.ApplicationDescriptor descriptor, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "updateApplication", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).updateApplication(descriptor, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void updateServer(IcePack.ServerDescriptor server, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "updateServer", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).updateServer(server, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}

	public void writeMessage(string name, string message, int fd, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "writeMessage", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Admin)
		{
		    try
		    {
			((Admin)__servant).writeMessage(name, message, fd, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}
    }
}

namespace IcePack
{
    public abstract class _AdminDisp : Ice.ObjectImpl, Admin
    {
	#region Slice operations

	public void addApplication(IcePack.ApplicationDescriptor descriptor)
	{
	    addApplication(descriptor, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void addApplication(IcePack.ApplicationDescriptor descriptor, Ice.Current __current);

	public void updateApplication(IcePack.ApplicationDescriptor descriptor)
	{
	    updateApplication(descriptor, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void updateApplication(IcePack.ApplicationDescriptor descriptor, Ice.Current __current);

	public string[] getAllApplicationNames()
	{
	    return getAllApplicationNames(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract string[] getAllApplicationNames(Ice.Current __current);

	public void removeApplication(string name)
	{
	    removeApplication(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void removeApplication(string name, Ice.Current __current);

	public IcePack.ApplicationDescriptor getApplicationDescriptor(string name)
	{
	    return getApplicationDescriptor(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract IcePack.ApplicationDescriptor getApplicationDescriptor(string name, Ice.Current __current);

	public void addServer(IcePack.ServerDescriptor server)
	{
	    addServer(server, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void addServer(IcePack.ServerDescriptor server, Ice.Current __current);

	public void updateServer(IcePack.ServerDescriptor server)
	{
	    updateServer(server, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void updateServer(IcePack.ServerDescriptor server, Ice.Current __current);

	public void removeServer(string name)
	{
	    removeServer(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void removeServer(string name, Ice.Current __current);

	public IcePack.ServerDescriptor getServerDescriptor(string name)
	{
	    return getServerDescriptor(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract IcePack.ServerDescriptor getServerDescriptor(string name, Ice.Current __current);

	public IcePack.ServerState getServerState(string name)
	{
	    return getServerState(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract IcePack.ServerState getServerState(string name, Ice.Current __current);

	public int getServerPid(string name)
	{
	    return getServerPid(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract int getServerPid(string name, Ice.Current __current);

	public IcePack.ServerActivation getServerActivation(string name)
	{
	    return getServerActivation(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract IcePack.ServerActivation getServerActivation(string name, Ice.Current __current);

	public void setServerActivation(string name, IcePack.ServerActivation mode)
	{
	    setServerActivation(name, mode, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void setServerActivation(string name, IcePack.ServerActivation mode, Ice.Current __current);

	public bool startServer(string name)
	{
	    return startServer(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract bool startServer(string name, Ice.Current __current);

	public void stopServer(string name)
	{
	    stopServer(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void stopServer(string name, Ice.Current __current);

	public void sendSignal(string name, string signal)
	{
	    sendSignal(name, signal, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void sendSignal(string name, string signal, Ice.Current __current);

	public void writeMessage(string name, string message, int fd)
	{
	    writeMessage(name, message, fd, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void writeMessage(string name, string message, int fd, Ice.Current __current);

	public string[] getAllServerNames()
	{
	    return getAllServerNames(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract string[] getAllServerNames(Ice.Current __current);

	public string getAdapterEndpoints(string id)
	{
	    return getAdapterEndpoints(id, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract string getAdapterEndpoints(string id, Ice.Current __current);

	public string[] getAllAdapterIds()
	{
	    return getAllAdapterIds(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract string[] getAllAdapterIds(Ice.Current __current);

	public void addObject(Ice.ObjectPrx obj)
	{
	    addObject(obj, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void addObject(Ice.ObjectPrx obj, Ice.Current __current);

	public void addObjectWithType(Ice.ObjectPrx obj, string type)
	{
	    addObjectWithType(obj, type, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void addObjectWithType(Ice.ObjectPrx obj, string type, Ice.Current __current);

	public void removeObject(Ice.ObjectPrx obj)
	{
	    removeObject(obj, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void removeObject(Ice.ObjectPrx obj, Ice.Current __current);

	public bool pingNode(string name)
	{
	    return pingNode(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract bool pingNode(string name, Ice.Current __current);

	public void shutdownNode(string name)
	{
	    shutdownNode(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void shutdownNode(string name, Ice.Current __current);

	public void removeNode(string name)
	{
	    removeNode(name, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void removeNode(string name, Ice.Current __current);

	public string[] getAllNodeNames()
	{
	    return getAllNodeNames(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract string[] getAllNodeNames(Ice.Current __current);

	public void shutdown()
	{
	    shutdown(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void shutdown(Ice.Current __current);

	public Ice.SliceChecksumDict getSliceChecksums()
	{
	    return getSliceChecksums(Ice.ObjectImpl.defaultCurrent);
	}

	public abstract Ice.SliceChecksumDict getSliceChecksums(Ice.Current __current);

	#endregion

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::Ice::Object",
	    "::IcePack::Admin"
	};

	public override bool ice_isA(string s)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		return _System.Array.BinarySearch(__ids, s) >= 0;
	    }else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[1];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[1];
	}

	public static new string ice_staticId()
	{
	    return __ids[1];
	}

	#endregion

	#region Operation dispatch

	public static IceInternal.DispatchStatus ___addApplication(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    IceInternal.ParamPatcher descriptor_PP = new IceInternal.ParamPatcher(typeof(IcePack.ApplicationDescriptor));
	    __is.readObject(descriptor_PP);
	    __is.readPendingObjects();
	    try
	    {
		__obj.addApplication((IcePack.ApplicationDescriptor)descriptor_PP.value, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.DeploymentException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___updateApplication(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    IceInternal.ParamPatcher descriptor_PP = new IceInternal.ParamPatcher(typeof(IcePack.ApplicationDescriptor));
	    __is.readObject(descriptor_PP);
	    __is.readPendingObjects();
	    try
	    {
		__obj.updateApplication((IcePack.ApplicationDescriptor)descriptor_PP.value, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.DeploymentException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___getAllApplicationNames(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    string[] __ret = __obj.getAllApplicationNames(__current);
	    __os.writeStringSeq(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___removeApplication(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		__obj.removeApplication(name, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.ApplicationNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___getApplicationDescriptor(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		IcePack.ApplicationDescriptor __ret = __obj.getApplicationDescriptor(name, __current);
		__os.writeObject(__ret);
		__os.writePendingObjects();
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.ApplicationNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___addServer(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    IceInternal.ParamPatcher server_PP = new IceInternal.ParamPatcher(typeof(IcePack.ServerDescriptor));
	    __is.readObject(server_PP);
	    __is.readPendingObjects();
	    try
	    {
		__obj.addServer((IcePack.ServerDescriptor)server_PP.value, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.DeploymentException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___updateServer(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    IceInternal.ParamPatcher server_PP = new IceInternal.ParamPatcher(typeof(IcePack.ServerDescriptor));
	    __is.readObject(server_PP);
	    __is.readPendingObjects();
	    try
	    {
		__obj.updateServer((IcePack.ServerDescriptor)server_PP.value, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.DeploymentException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.ServerNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___removeServer(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		__obj.removeServer(name, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.DeploymentException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.ServerNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___getServerDescriptor(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		IcePack.ServerDescriptor __ret = __obj.getServerDescriptor(name, __current);
		__os.writeObject(__ret);
		__os.writePendingObjects();
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.ServerNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___getServerState(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		IcePack.ServerState __ret = __obj.getServerState(name, __current);
		__os.writeByte((byte)__ret);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.NodeUnreachableException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.ServerNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___getServerPid(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		int __ret = __obj.getServerPid(name, __current);
		__os.writeInt(__ret);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.NodeUnreachableException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.ServerNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___getServerActivation(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		IcePack.ServerActivation __ret = __obj.getServerActivation(name, __current);
		__os.writeByte((byte)__ret);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.NodeUnreachableException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.ServerNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___setServerActivation(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    IcePack.ServerActivation mode;
	    mode = (IcePack.ServerActivation)__is.readByte();
	    try
	    {
		__obj.setServerActivation(name, mode, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.NodeUnreachableException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.ServerNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___startServer(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		bool __ret = __obj.startServer(name, __current);
		__os.writeBool(__ret);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.NodeUnreachableException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.ServerNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___stopServer(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		__obj.stopServer(name, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.NodeUnreachableException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.ServerNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___sendSignal(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    string signal;
	    signal = __is.readString();
	    try
	    {
		__obj.sendSignal(name, signal, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.BadSignalException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.NodeUnreachableException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.ServerNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___writeMessage(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    string message;
	    message = __is.readString();
	    int fd;
	    fd = __is.readInt();
	    try
	    {
		__obj.writeMessage(name, message, fd, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.NodeUnreachableException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.ServerNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___getAllServerNames(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    string[] __ret = __obj.getAllServerNames(__current);
	    __os.writeStringSeq(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___getAdapterEndpoints(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string id;
	    id = __is.readString();
	    try
	    {
		string __ret = __obj.getAdapterEndpoints(id, __current);
		__os.writeString(__ret);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.AdapterNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.NodeUnreachableException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___getAllAdapterIds(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    string[] __ret = __obj.getAllAdapterIds(__current);
	    __os.writeStringSeq(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___addObject(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    Ice.ObjectPrx obj;
	    obj = __is.readProxy();
	    try
	    {
		__obj.addObject(obj, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.DeploymentException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	    catch(IcePack.ObjectExistsException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___addObjectWithType(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    Ice.ObjectPrx obj;
	    obj = __is.readProxy();
	    string type;
	    type = __is.readString();
	    try
	    {
		__obj.addObjectWithType(obj, type, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.ObjectExistsException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___removeObject(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    Ice.ObjectPrx obj;
	    obj = __is.readProxy();
	    try
	    {
		__obj.removeObject(obj, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.ObjectNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___pingNode(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		bool __ret = __obj.pingNode(name, __current);
		__os.writeBool(__ret);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.NodeNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___shutdownNode(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		__obj.shutdownNode(name, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.NodeNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___removeNode(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __in.istr();
	    IceInternal.BasicStream __os = __in.ostr();
	    string name;
	    name = __is.readString();
	    try
	    {
		__obj.removeNode(name, __current);
		return IceInternal.DispatchStatus.DispatchOK;
	    }
	    catch(IcePack.NodeNotExistException ex)
	    {
		__os.writeUserException(ex);
		return IceInternal.DispatchStatus.DispatchUserException;
	    }
	}

	public static IceInternal.DispatchStatus ___getAllNodeNames(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    string[] __ret = __obj.getAllNodeNames(__current);
	    __os.writeStringSeq(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___shutdown(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    __obj.shutdown(__current);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	public static IceInternal.DispatchStatus ___getSliceChecksums(Admin __obj, IceInternal.Incoming __in, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __in.ostr();
	    Ice.SliceChecksumDict __ret = __obj.getSliceChecksums(__current);
	    Ice.SliceChecksumDictHelper.write(__os, __ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	private static string[] __all =
	{
	    "addApplication",
	    "addObject",
	    "addObjectWithType",
	    "addServer",
	    "getAdapterEndpoints",
	    "getAllAdapterIds",
	    "getAllApplicationNames",
	    "getAllNodeNames",
	    "getAllServerNames",
	    "getApplicationDescriptor",
	    "getServerActivation",
	    "getServerDescriptor",
	    "getServerPid",
	    "getServerState",
	    "getSliceChecksums",
	    "ice_id",
	    "ice_ids",
	    "ice_isA",
	    "ice_ping",
	    "pingNode",
	    "removeApplication",
	    "removeNode",
	    "removeObject",
	    "removeServer",
	    "sendSignal",
	    "setServerActivation",
	    "shutdown",
	    "shutdownNode",
	    "startServer",
	    "stopServer",
	    "updateApplication",
	    "updateServer",
	    "writeMessage"
	};

	public override IceInternal.DispatchStatus __dispatch(IceInternal.Incoming __in, Ice.Current __current)
	{int pos;
	    if(_System.Type.GetType("Mono.Runtime", false) != null) // Bug in Mono 1.0 DefaultInvariant
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation);
	    }
	    else
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation, _System.Collections.Comparer.DefaultInvariant);
	    }
	    if(pos < 0)
	    {
		return IceInternal.DispatchStatus.DispatchOperationNotExist;
	    }

	    switch(pos)
	    {
		case 0:
		{
		    return ___addApplication(this, __in, __current);
		}
		case 1:
		{
		    return ___addObject(this, __in, __current);
		}
		case 2:
		{
		    return ___addObjectWithType(this, __in, __current);
		}
		case 3:
		{
		    return ___addServer(this, __in, __current);
		}
		case 4:
		{
		    return ___getAdapterEndpoints(this, __in, __current);
		}
		case 5:
		{
		    return ___getAllAdapterIds(this, __in, __current);
		}
		case 6:
		{
		    return ___getAllApplicationNames(this, __in, __current);
		}
		case 7:
		{
		    return ___getAllNodeNames(this, __in, __current);
		}
		case 8:
		{
		    return ___getAllServerNames(this, __in, __current);
		}
		case 9:
		{
		    return ___getApplicationDescriptor(this, __in, __current);
		}
		case 10:
		{
		    return ___getServerActivation(this, __in, __current);
		}
		case 11:
		{
		    return ___getServerDescriptor(this, __in, __current);
		}
		case 12:
		{
		    return ___getServerPid(this, __in, __current);
		}
		case 13:
		{
		    return ___getServerState(this, __in, __current);
		}
		case 14:
		{
		    return ___getSliceChecksums(this, __in, __current);
		}
		case 15:
		{
		    return ___ice_id(this, __in, __current);
		}
		case 16:
		{
		    return ___ice_ids(this, __in, __current);
		}
		case 17:
		{
		    return ___ice_isA(this, __in, __current);
		}
		case 18:
		{
		    return ___ice_ping(this, __in, __current);
		}
		case 19:
		{
		    return ___pingNode(this, __in, __current);
		}
		case 20:
		{
		    return ___removeApplication(this, __in, __current);
		}
		case 21:
		{
		    return ___removeNode(this, __in, __current);
		}
		case 22:
		{
		    return ___removeObject(this, __in, __current);
		}
		case 23:
		{
		    return ___removeServer(this, __in, __current);
		}
		case 24:
		{
		    return ___sendSignal(this, __in, __current);
		}
		case 25:
		{
		    return ___setServerActivation(this, __in, __current);
		}
		case 26:
		{
		    return ___shutdown(this, __in, __current);
		}
		case 27:
		{
		    return ___shutdownNode(this, __in, __current);
		}
		case 28:
		{
		    return ___startServer(this, __in, __current);
		}
		case 29:
		{
		    return ___stopServer(this, __in, __current);
		}
		case 30:
		{
		    return ___updateApplication(this, __in, __current);
		}
		case 31:
		{
		    return ___updateServer(this, __in, __current);
		}
		case 32:
		{
		    return ___writeMessage(this, __in, __current);
		}
	    }

	    _System.Diagnostics.Debug.Assert(false);
	    return IceInternal.DispatchStatus.DispatchOperationNotExist;
	}

	#endregion
    }
}

namespace IcePack
{
}
